/*=======================================================================================================*/
/*                                                                                                       */
/* This is crypto version .06. It is a neat little PERSONAL encryption program. It should NOT be used    */
/* on extra sensitive files as this program is not completely un-crackable.                              */
/* To compile, simply : gcc -o crypto crypto-0.6.c  =)                                                   */
/*                                                                                                       */
/*=======================================================================================================*/
#include <stdio.h>
#include <string.h>
#include <stdlib.h>                            /* need to play with files  */
#include <unistd.h>                            /* needed getopt() function */

#define VERSION "version 0.06"
#define REC_OPTIONS "vhe:d:k:"                 /* REC_OPTIONS is used in the getopt() funciton. v, h, e, d, & k are the available command */
                                               /* line options. the ':' after e and d tells getopt() that e and d REQUIRE                 */
                                               /* additional parameters(the file to be enc'd or dec'd)           man getopt  =)           */
main(argc, argv)
int argc;
char *argv[];

{
 FILE *fp;
 void decr();            /* the encryption function */
 void encr();            /* the decryption function */
 void h_elp();           /* displays a help message */
 void v_ersion();        /* displays current version and maybee more info */
 int get_key();          /* calculates the give key from the command line option '-k' */

 char ch;                /* used in the getopt() function for command line parsing */
 char progflag;          /* program flags, decides the fate of the program =)       */
 char *filename;          /* this will be the file to work on. assigned from getopt() */
 char mask;
 int key;
 
 if ( argc == 1 )
 {
  h_elp(argv[0]);
  exit(1);
 }

 while ((ch = getopt(argc, argv, REC_OPTIONS)) != -1)
 {
  switch (ch)
  {
   case 'v' :
    v_ersion();
    break;
   case 'h' :
    h_elp(argv[0]);
    break;
   case 'k' :
    key = get_key(optarg);        /* optarg is defined in <unistd.h>.                                                           */
    mask = optarg[0];            /* optarg is the next string after the option that getopt() is parsing. man getopt. =)        */
    break;                        
   case 'd' :
    filename = optarg;       
    progflag = 'd';
    break;
   case 'e' :
    filename = optarg;
    progflag = 'e';
    break;
   default :
    printf("seems like you are entering invalid options to the program\n");
    printf("type %s -h for help.\n", argv[0]);
    exit(2);
  }
 }

if ( argc == 5 )
 {
  if ( (fp = fopen(filename, "r+")) == NULL )
   {
     fprintf(stderr, "Can't open %s for some reason\n", argv[4]);
     exit(3);
   }
 }
 else 
  {
   printf("You are giving invalid options to the program\n");
   printf("Type %s -h for help\n", argv[0]);
   exit(4); 
 }
  
 switch (progflag)
  {
   case 'e' :
    encr(fp,key,mask);
    break;
   case 'd' :
    decr(fp,key,mask);
    break;
   default :
    printf("something very screwy is happening\n");
  }
 fclose(fp);
}


/*=============================================================================================================*/
/*                                                                                                             */
/* This is the key function                                                                                    */
/* It will take a string pointer as an argument. This string pointer points to string which represents what    */
/* the end user would like to use a the decrypt and encrypt key =)                                             */
/*                                                                                                             */      
/*=============================================================================================================*/
int get_key(str)
char *str;
{
 int key;
 int total = 0;
 int ct = 0;
 int i;
 char temp[5];
 size_t n = 5;                /* These two statements let us copy the elements of the 'str' pointer that passed   */
 strncpy(temp, str, n);       /* as an arument to this function to another string-'temp' which we can work better */
                              /* since temp is not a pointer, but an actual string.                               */
                              /* note that strncpy(cpy, dest, n) only copies n chars from 'dest' to 'cpy' which   */
                              /* prevents buffer overflow >=]                                                     */ 

for (i = 0; i < (strlen(temp)); i++)
  {
   ct++;
   total += (int)temp[i];   /* force an int */
  }
 key = (total / ct);
 return (int)key;           /* forcing an int value */
}

/*=======================================================================================================================*/
/*                                                                                                                       */
/* This is the encryption function. It take a file pointer 'enc' and an int value 'key'. The file enc is encrypted based */   
/* on what the value of key is. as of ver4, the function takes a third argument 'mask'. 'mask' is used in conjunction    */
/* with the ^ OR operator to further encrypt the file.--super-dooper-encryption!! ;-)                                    */
/*                                                                                                                       */ 
/*=======================================================================================================================*/
void encr(enc,key,mask)
FILE *enc;
int key;
char mask;
{
 char ch;
 int u_flag = 1;
 int count = 0;
 
 while ( (ch = getc(enc)) != EOF )
  {
   if ( u_flag == 1 )
    {
     if ( count == 10 )
      u_flag = 0;      
     else
      count++;
    }
   if ( u_flag == 0 )
    {
     if ( count == 0 )
      u_flag = 1;
     else
      count--;
    }
  fseek(enc, -1, SEEK_CUR);       
  ch += (count + key) ^ mask;      
  putc(ch, enc);
  }
}

/*=======================================================================================================================*/
/*                                                                                                                       */
/* This is the decryption function. It takes a file pointer 'dec' and an int value 'key' as arguments. It then decrypts  */  
/* the dec file based on what the key is. It also takes 'mask' as an argument. 'mask' is used to help decrypt the file   */
/* read the documentation for the enc() function for more details                                                        */
/*                                                                                                                       */ 
/*=======================================================================================================================*/
decr(dec,key,mask)
FILE *dec; 
int key;
char mask;
{  
 char ch;
 int u_flag = 1;
 int count = 0;
   
 while ( (ch = getc(dec)) != EOF )
  {
   if ( u_flag == 1 )
    {
     if ( count == 10 )
      u_flag = 0;
     else
      count++;
    }
   if ( u_flag == 0 )
    {
     if ( count == 0 )
      u_flag = 1;
     else
      count--;
    }
  fseek(dec, -1, SEEK_CUR);
  ch -= (count + key) ^ mask;
  putc(ch, dec);
  }
}

/*===================================================================================================================*/
/*                                                                                                                   */
/* This is the help function. It prints out a help message when the end user uses the program in a wrong way         */
/*                                                                                                                   */
/*===================================================================================================================*/
void h_elp(name)
char *name[];
{
 printf("Options are -e , -d , -k, -h , and -h\n");
 printf("USE 1: %s [-v , -h ]\n", name);
 printf("USE 2: %s [-e, -d] FILENAME -k YOUR_KEY\n", name);
 putchar('\n');
 printf("-e or -d specifies to encrypt or decrypt(respectively) FILENAME.\n");
 printf("FILENAME specifies the name of the file you wish to work on.\n");
 printf("-k specifies that YOUR_KEY should be used to encrypt the file.\n");
 printf("YOUR_KEY can be any combination of five characters or numbers.\n");
 printf("***BE SURE to remember YOUR_KEY so you can decrypt the file.\n");
 exit(0);
 }

/*=================================================================================================================*/
/*                                                                                                                 */
/* This is the version function. pretty redundant =)                                                               */
/*                                                                                                                 */
/*=================================================================================================================*/
void v_ersion()
{
 printf("%s\n", VERSION);
 exit(0);
}
